/* CTP communication HW layer
 *
 * Copyright (C) 2010 QuickDevice Technologies Co. Ltd.
 *
 * This UART communication implementation is based on VC of Windows.
 *
 * Note that: Need replace this file with HC(Host Controller) UART driver.
 *            Different HC system maybe has different drivers.
 */
#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <tchar.h>
#include <string.h>
#include <process.h>
#include <stdlib.h>

int userBaudRate,idBaudRate;
int userComPort;

HANDLE idComDev;
volatile int isConnected=FALSE;

/*****************************
 *                           *
 * serial communication part *
 *                           *
 *****************************/

void hw_init(void)
//port=1,2,3,4
{
    DCB dcb;
    COMMTIMEOUTS commTimeOuts;
    
  
//====================================================
    idComDev=CreateFile(TEXT("COM1"),
			GENERIC_READ|GENERIC_WRITE,
			0, //exclusive access
			/*FILE_SHARE_READ|FILE_SHARE_WRITE,*/ 
			NULL,	
			OPEN_EXISTING,
			0,
			NULL);

    if(idComDev==INVALID_HANDLE_VALUE)
    {
	//EB_Printf(TEXT("[ERROR:CreateFile for opening COM port.]\n") );
    }

    SetCommMask(idComDev,EV_RXCHAR);
    SetupComm(idComDev,4096,4096);
    PurgeComm(idComDev,PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR);
    
    commTimeOuts.ReadIntervalTimeout=0xffffffff;
    commTimeOuts.ReadTotalTimeoutMultiplier=0;
    commTimeOuts.ReadTotalTimeoutConstant=1000;
    commTimeOuts.WriteTotalTimeoutMultiplier=0;
    commTimeOuts.WriteTotalTimeoutConstant=1000;
    SetCommTimeouts(idComDev,&commTimeOuts);

//====================================================
    dcb.DCBlength=sizeof(DCB);
    GetCommState(idComDev,&dcb);

    dcb.fBinary=TRUE;
    dcb.fParity=FALSE;
    dcb.BaudRate=115200;//CBR_115200;
    dcb.ByteSize=8;
    dcb.Parity=0;
    dcb.StopBits=ONESTOPBIT;
    dcb.fDtrControl=DTR_CONTROL_DISABLE;
    dcb.fRtsControl=RTS_CONTROL_DISABLE;
    dcb.fOutxCtsFlow=0;
    dcb.fOutxDsrFlow=0;
    
    if(SetCommState(idComDev,&dcb)==TRUE)
    {	
	isConnected=TRUE;
	//if(!SetCommMask(idComDev,EV_RXCHAR|EV_TXEMPTY|EV_ERR))
	if(!SetCommMask(idComDev,EV_RXCHAR|EV_ERR))
    {
	//printf(TEXT("[ERROR:SetCommMask()]\n"));
    }
    }
    else
    {
	isConnected=FALSE;
	CloseHandle(idComDev);
    }
}

void CloseComPort(void)
{
    if(isConnected)
    {
	isConnected=FALSE;
	SetCommMask(idComDev,0);
	    //disable event notification and wait for thread to halt
	EscapeCommFunction(idComDev,CLRDTR);
	PurgeComm(idComDev,PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR);
	CloseHandle(idComDev);
    }
    
    Sleep(100); 
    //wait until CloseComPort() effective.
    //If not, OpenComPort()::CreateFile(...) will fail.

}
	
unsigned int hw_read(char *buf, unsigned int sz)
{
    DWORD dwLength;
	DWORD dwEvtMask;
    COMSTAT comStat;
    DWORD dwErrorFlags;

    if (!isConnected)
    	return 0;	

	while (1)
	{
	dwEvtMask=0;
	WaitCommEvent(idComDev,&dwEvtMask,NULL);  //wait until any event is occurred.

	if((dwEvtMask & EV_RXCHAR) == EV_RXCHAR)
	{
    ClearCommError(idComDev,&dwErrorFlags,&comStat);
    dwLength=min((DWORD)sz,comStat.cbInQue);
    if(dwLength>0)
	if(!ReadFile(idComDev,buf,dwLength,&dwLength,NULL))
	{
	    //printf(TEXT("[RXERR]") );
	    continue;
	}
	break;
	}

	if(dwEvtMask & EV_ERR)
	{
	    COMSTAT comStat;
	    DWORD dwErrorFlags;
	    ClearCommError(idComDev,&dwErrorFlags,&comStat);
	    //EB_Printf(TEXT("[DBG:EV_ERR=%x]\n"),dwErrorFlags);
	}

	}

	return dwLength;    

}

void hw_write(char *buf, unsigned int sz)
{
    DWORD temp;
    
    WriteFile(idComDev,(void *)buf,(DWORD)sz,&temp,NULL);
}
    

